﻿Imports System.ComponentModel

Public Class Form1
    Dim info As BindingList(Of Person) = New BindingList(Of Person)()
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        info.Add(New Person("Jon", "Player", 34))
        info.Add(New Person("Jon1", "Player1", 33))
        info.Add(New Person("Jon2", "Player2", 32))
        info.Add(New Person("Jon3", "Player3", 36))
        info.Add(New Person("Jon4", "Player4", 38))
        C1FlexGrid1.DataSource = info
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        info(0).Age = 21
        info(0).FirstName = "John0"
        info(1).LastName = "Player0"
    End Sub
End Class
Class Person
    Implements INotifyPropertyChanged
    Public Event PropertyChanged As PropertyChangedEventHandler
    Private Event INotifyPropertyChanged_PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Private _FirstName As String
    Private _LastName As String
    Private _Age As Integer
    Public Sub New(ByVal FirstName As String, ByVal LastName As String, ByVal Age As Integer)
        Me._FirstName = FirstName
        Me._LastName = LastName
        Me._Age = Age
    End Sub
    Public Property FirstName As String
        Get
            Return _FirstName
        End Get
        Set(ByVal value As String)

            If _FirstName <> value Then
                _FirstName = value
                OnPropertyChanged("FirstName")
            End If
        End Set
    End Property
    Public Property LastName As String
        Get
            Return _LastName
        End Get
        Set(ByVal value As String)

            If _LastName <> value Then
                _LastName = value
                OnPropertyChanged("LastName")
            End If
        End Set
    End Property
    Public Property Age As Integer
        Get
            Return _Age
        End Get
        Set(ByVal value As Integer)

            If _Age <> value Then
                _Age = value
                OnPropertyChanged("Age")
            End If
        End Set
    End Property
    Overridable Sub OnPropertyChanged(ByVal [property] As String)
        RaiseEvent INotifyPropertyChanged_PropertyChanged(Me, New PropertyChangedEventArgs([property]))
    End Sub
End Class

